import 'package:assets_audio_player/assets_audio_player.dart';
import 'package:external_app_launcher/external_app_launcher.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:get/get.dart';
import 'package:in_app_review/in_app_review.dart';
import 'package:in_app_update/in_app_update.dart';
import 'package:lottie/lottie.dart';
import 'package:package_info_plus/package_info_plus.dart';
import 'package:scroll_loop_auto_scroll/scroll_loop_auto_scroll.dart';
import 'package:url_launcher/url_launcher.dart';

import 'get_controller.dart';
import 'model_class.dart';

class PPDialog {
  static updateDialog(BuildContext context,
      {required bool isPopupRequired,
      required bool isPopup,
      required int apiVersionCode,
      required String appLogoApi,
      required String appNameApi,
      required String subtitleAppApi,
      required String appWebsiteUrl}) async {
    if ((isPopup == true &&
        (apiVersionCode) > int.parse(AppDetailsPP.to.buildNumber.value))) {
      AssetsAudioPlayer.newPlayer().open(
        Audio("packages/dialog_pp_flutter/assets/dialogs_assets/music.wav"),
        autoStart: true,
        showNotification: false,
      );

      Get.defaultDialog(
          onWillPop: () async {
            if (isPopupRequired == true) {
              return false;
            } else {
              return true;
            }
          },
          barrierDismissible: isPopupRequired == true ? false : true,
          title: "",
          content: Stack(
            children: [
              Column(
                children: [
                  Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      Align(
                        alignment: Alignment.topRight,
                        child: Lottie.asset(
                            "packages/dialog_pp_flutter/assets/dialogs_assets/bell.json",
                            height: 70.h),
                      ),
                      Text(
                        "Alert".tr,
                        style: TextStyle(
                            fontSize: 24.w, fontWeight: FontWeight.bold),
                      ),
                      const Text(
                        " (Ad)",
                        style: TextStyle(color: Colors.grey),
                      ),
                    ],
                  ),
                  const SizedBox(
                    height: 20,
                  ),
                  if (appLogoApi.isEmpty)
                    Container(
                      decoration: const BoxDecoration(
                          borderRadius: BorderRadius.all(Radius.circular(20))),
                      child: Container(
                        decoration: const BoxDecoration(
                            borderRadius:
                                BorderRadius.all(Radius.circular(20))),
                        child: Image.asset(
                          "packages/dialog_pp_flutter/assets/dialogs_assets/playstore.png",
                          height: 250.h,
                        ),
                      ),
                    )
                  else
                    Container(
                      decoration: BoxDecoration(
                        borderRadius:
                            const BorderRadius.all(Radius.circular(30)),
                        boxShadow: [
                          BoxShadow(
                            color: Colors.black.withOpacity(0.3),
                            spreadRadius: 2,
                            blurRadius: 5,
                            offset: const Offset(
                                4, 10), // changes position of shadow
                          ),
                        ],
                      ),
                      child: ClipRRect(
                        borderRadius:
                            const BorderRadius.all(Radius.circular(30)),
                        child: InkWell(
                          onTap: () async {
                            DialogGetController.to.noThankButton.value = true;

                            var packageid = appWebsiteUrl.split("?id=");

                            await LaunchApp.openApp(
                                androidPackageName: packageid[1],
                                iosUrlScheme: 'pulsesecure://',
                                appStoreLink:
                                    'itms-apps://itunes.apple.com/us/app/pulse-secure/id945832041');
                            // launch(appWebsiteUrl);
                          },
                          child: Image.network(
                            appLogoApi,
                            fit: BoxFit.fill,
                            height: 190.h,
                            width: 190.h,
                          ),
                        ),
                      ),
                    ),
                ],
              ),
            ],
          ),
          actions: [
            Column(
              children: [
                SizedBox(
                  height: 20.h,
                ),
                Text(appNameApi.tr,
                    style: const TextStyle(
                        color: Colors.black, fontWeight: FontWeight.bold)),
                SizedBox(
                  height: 10.h,
                ),
                Text(subtitleAppApi.tr, textAlign: TextAlign.center),
                SizedBox(
                  height: 5.h,
                )
              ],
            )
          ],
          backgroundColor: Colors.white,
          titleStyle: const TextStyle(
              color: Colors.black, fontWeight: FontWeight.bold, height: 00),
          middleTextStyle: const TextStyle(
            color: Colors.white,
          ),
          confirm: Padding(
            padding: EdgeInsets.only(bottom: 10.h),
            child: Stack(
              children: [
                Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  crossAxisAlignment: CrossAxisAlignment.center,
                  children: [
                    isPopupRequired == false
                        ? InkWell(
                            onTap: () {
                              Get.back();
                            },
                            child: Text(
                              "No Thanks".tr,
                              style: const TextStyle(
                                  color: Color(0xff007A3D),
                                  fontWeight: FontWeight.bold),
                            ),
                          )
                        : Obx(
                            () => DialogGetController.to.noThankButton.value ==
                                    true
                                ? Padding(
                                    padding: EdgeInsets.only(right: 30.w),
                                    child: InkWell(
                                      onTap: () {
                                        Get.back();
                                      },
                                      child: Text(
                                        "No Thanks".tr,
                                        style: const TextStyle(
                                            color: Color(0xff007A3D),
                                            fontWeight: FontWeight.bold),
                                      ),
                                    ),
                                  )
                                : Container(),
                          ),
                    SizedBox(
                      width: isPopupRequired == true ? 0.w : 30.w,
                    ),
                    Container(
                      height: 50.h,
                      decoration: const BoxDecoration(
                        borderRadius: BorderRadius.all(Radius.circular(20)),
                      ),
                      width: 150.w,
                      child: Row(
                        children: [
                          InkWell(
                            child: Container(
                              width: 150.w,
                              height: 50.h,
                              decoration: const BoxDecoration(
                                image: DecorationImage(
                                  image: AssetImage(
                                      "packages/dialog_pp_flutter/assets/dialogs_assets/playstore.png"),
                                  fit: BoxFit.fitWidth,
                                  alignment: Alignment.topCenter,
                                ),
                              ),
                            ),
                            onTap: () async {
                              DialogGetController.to.noThankButton.value = true;

                              var packageid = appWebsiteUrl.split("?id=");

                              await LaunchApp.openApp(
                                  androidPackageName: packageid[1],
                                  iosUrlScheme: 'pulsesecure://',
                                  appStoreLink:
                                      'itms-apps://itunes.apple.com/us/app/pulse-secure/id945832041');
                            },
                          )
                        ],
                      ),
                    ),
                    SizedBox(
                      height: 20.h,
                    )
                  ],
                ),
              ],
            ),
          ),
          // confirm: Container(
          //   child: Text("Download App"),
          // ),
          radius: 10);
    }
  }

  static newVersionCode() async {
    WidgetsFlutterBinding.ensureInitialized();
    PackageInfo packageInfo = await PackageInfo.fromPlatform();
    AppDetailsPP.to.appName.value = packageInfo.appName;
    AppDetailsPP.to.packageName.value = packageInfo.packageName;
    AppDetailsPP.to.versionApp.value = packageInfo.version;
    AppDetailsPP.to.buildNumber.value = packageInfo.buildNumber;
  }

  static Future<void> autoUpdate() async {
    InAppUpdate.checkForUpdate().then((info) {}).catchError((e) {
      if (kDebugMode) {
        print(e.toString());
      }
    }).then((value) => {
          InAppUpdate.startFlexibleUpdate(),
        });
  }

  static autoRate() {
    final InAppReview inAppReview = InAppReview.instance;

    WidgetsBinding.instance.addPostFrameCallback((_) async {
      await inAppReview.isAvailable();
    });

    Future<void> _requestReview() => inAppReview.requestReview();
    _requestReview();
  }

  static drawerScreen(
      {required String appLogo,
      required String privacyPolicy,
      required String feedbackEmailId,
      required String emailSubject,
      required String emailMessage}) {
    late ScrollController scrollController = ScrollController();
    return Drawer(
        backgroundColor: Colors.transparent,
        width: 300.r,
        child: SafeArea(
          child: ClipRRect(
            borderRadius: BorderRadius.only(
                topRight: Radius.circular(20.r),
                bottomRight: Radius.circular(20.r)),
            child: Scaffold(
              backgroundColor: Colors.white,
              body: Padding(
                padding: EdgeInsets.symmetric(horizontal: 10.r),
                child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Center(
                        child: Container(
                          height: 120.h,
                          width: 120.h,
                          decoration: BoxDecoration(
                              borderRadius:
                                  const BorderRadius.all(Radius.circular(20)),
                              border: Border.all()),
                          margin: EdgeInsets.only(top: 10.r, bottom: 10.r),
                          child: Image.asset(
                            "packages/dialog_pp_flutter/$appLogo",
                            fit: BoxFit.fill,
                          ),
                        ),
                      ),
                      Divider(color: Colors.black.withOpacity(0.75)),
                      InkWell(
                        splashColor: Colors.transparent,
                        highlightColor: Colors.transparent,
                        onTap: () {
                          launch(privacyPolicy);
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            SizedBox(
                                height: 25.h,
                                width: 25.h,
                                child: Image.asset(
                                  "packages/dialog_pp_flutter/assets/dialogs_assets/privacy.png",
                                  color: Colors.black,
                                )),
                            SizedBox(
                              width: 25.w,
                            ),
                            Text(
                              "Privacy Policy",
                              style: TextStyle(
                                fontWeight: FontWeight.w400,
                                color: Colors.black,
                                fontSize: 16.sp,
                              ),
                            ),
                            const Spacer()
                          ],
                        ),
                      ),
                      SizedBox(
                        height: 15.h,
                      ),
                      InkWell(
                        splashColor: Colors.transparent,
                        highlightColor: Colors.transparent,
                        onTap: () {
                          // ignore: deprecated_member_use
                          launch(
                              "$feedbackEmailId?subject=$emailSubject&body=$emailMessage");
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            Container(
                                height: 25.h,
                                width: 25.h,
                                padding: EdgeInsets.all(1.r),
                                child: Image.asset(
                                  "packages/dialog_pp_flutter/assets/dialogs_assets/feedback.png",
                                  color: Colors.black,
                                )),
                            SizedBox(
                              width: 25.w,
                            ),
                            Text(
                              "Feedback",
                              style: TextStyle(
                                fontWeight: FontWeight.w400,
                                color: Colors.black,
                                fontSize: 16.sp,
                              ),
                            ),
                            const Spacer()
                          ],
                        ),
                      ),
                      SizedBox(
                        height: 15.h,
                      ),
                      InkWell(
                        splashColor: Colors.transparent,
                        highlightColor: Colors.transparent,
                        onTap: () {
                          Future.delayed(const Duration(seconds: 0), () {
                            showAboutUs(Get.context!, appLogo);
                          });
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            SizedBox(
                                height: 25.h,
                                width: 25.h,
                                child: Image.asset(
                                    "packages/dialog_pp_flutter/assets/dialogs_assets/about.png",
                                    color: Colors.black)),
                            SizedBox(
                              width: 25.w,
                            ),
                            Text(
                              "About us",
                              style: TextStyle(
                                fontWeight: FontWeight.w400,
                                color: Colors.black,
                                fontSize: 16.sp,
                              ),
                            ),
                            const Spacer()
                          ],
                        ),
                      ),
                      Divider(color: Colors.black.withOpacity(0.75)),
                      moreLiveApp?.record.isNotEmpty == true
                          ? Expanded(
                              child: ScrollLoopAutoScroll(
                                scrollDirection: Axis.vertical,
                                enableScrollInput: true,
                                duration: const Duration(seconds: 120),
                                gap: 0,
                                reverseScroll: false,
                                child: ListView.builder(
                                  controller: scrollController,
                                  shrinkWrap: true,
                                  itemCount: moreLiveApp?.record.length,
                                  itemBuilder: (context, index) {
                                    String? packageNameFromJson =
                                        moreLiveApp?.record[index].links;
                                    String? fileName =
                                        packageNameFromJson?.replaceAll(
                                            "https://play.google.com/store/apps/details?id=",
                                            "");

                                    String? titleFinal;
                                    if (fileName ==
                                        AppDetailsPP.to.packageName.value) {
                                      titleFinal =
                                          moreLiveApp?.record[index].title;
                                    }

                                    return titleFinal !=
                                            moreLiveApp?.record[index].title
                                        ? InkWell(
                                            splashColor: Colors.transparent,
                                            highlightColor: Colors.transparent,
                                            onTap: () async {
                                              await LaunchApp.openApp(
                                                androidPackageName: fileName,
                                                iosUrlScheme: '',
                                              );
                                            },
                                            child: SizedBox(
                                              height: 70.h,
                                              child: Row(
                                                children: [
                                                  ClipRRect(
                                                    borderRadius:
                                                        BorderRadius.circular(
                                                            10.r),
                                                    child: SizedBox(
                                                      height: 60.h,
                                                      width: 60.h,
                                                      child: Image.network(
                                                        moreLiveApp!
                                                            .record[index]
                                                            .image,
                                                        loadingBuilder: (context,
                                                            child,
                                                            loadingProgress) {
                                                          if (loadingProgress ==
                                                              null) {
                                                            return child;
                                                          }
                                                          return Center(
                                                            child: SizedBox(
                                                              height: 20.h,
                                                              width: 20.h,
                                                              child:
                                                                  CircularProgressIndicator(
                                                                value: loadingProgress
                                                                            .expectedTotalBytes !=
                                                                        null
                                                                    ? loadingProgress
                                                                            .cumulativeBytesLoaded /
                                                                        loadingProgress
                                                                            .expectedTotalBytes!
                                                                    : null,
                                                              ),
                                                            ),
                                                          );
                                                        },
                                                      ),
                                                    ),
                                                  ),
                                                  SizedBox(
                                                    width: 10.w,
                                                  ),
                                                  Column(
                                                    mainAxisAlignment:
                                                        MainAxisAlignment
                                                            .center,
                                                    crossAxisAlignment:
                                                        CrossAxisAlignment
                                                            .start,
                                                    children: [
                                                      Row(
                                                        mainAxisAlignment:
                                                            MainAxisAlignment
                                                                .start,
                                                        children: [
                                                          SizedBox(
                                                            width: 160.w,
                                                            child: Text(
                                                              '${moreLiveApp!.record[index].title} ',
                                                              maxLines: 2,
                                                              style: TextStyle(
                                                                fontSize: 16.sp,
                                                                overflow:
                                                                    TextOverflow
                                                                        .ellipsis,
                                                                color: Colors
                                                                    .black,
                                                              ),
                                                            ),
                                                          ),
                                                          moreLiveApp!
                                                                      .record[
                                                                          index]
                                                                      .subtitle
                                                                      .isEmpty ==
                                                                  true
                                                              ? Text("(Ad)",
                                                                  style:
                                                                      TextStyle(
                                                                    fontSize:
                                                                        10.sp,
                                                                    overflow:
                                                                        TextOverflow
                                                                            .ellipsis,
                                                                    color: Colors
                                                                        .black38,
                                                                  ))
                                                              : const SizedBox(
                                                                  width: 0,
                                                                  height: 0,
                                                                )
                                                        ],
                                                      ),
                                                      moreLiveApp!
                                                                  .record[index]
                                                                  .subtitle
                                                                  .isNotEmpty ==
                                                              true
                                                          ? SizedBox(
                                                              height: 5.h,
                                                            )
                                                          : const SizedBox(
                                                              width: 0,
                                                              height: 0,
                                                            ),
                                                      moreLiveApp!
                                                                  .record[index]
                                                                  .subtitle
                                                                  .isNotEmpty ==
                                                              true
                                                          ? Row(
                                                              mainAxisAlignment:
                                                                  MainAxisAlignment
                                                                      .start,
                                                              children: [
                                                                SizedBox(
                                                                  width: 160.w,
                                                                  child: Text(
                                                                    moreLiveApp!
                                                                        .record[
                                                                            index]
                                                                        .subtitle,
                                                                    maxLines: 2,
                                                                    style:
                                                                        const TextStyle(
                                                                      overflow:
                                                                          TextOverflow
                                                                              .ellipsis,
                                                                      color: Colors
                                                                          .black38,
                                                                    ),
                                                                  ),
                                                                ),
                                                                moreLiveApp!
                                                                            .record[
                                                                                index]
                                                                            .subtitle
                                                                            .isNotEmpty ==
                                                                        true
                                                                    ? Text(
                                                                        "(Ad)",
                                                                        style:
                                                                            TextStyle(
                                                                          fontSize:
                                                                              10.sp,
                                                                          overflow:
                                                                              TextOverflow.ellipsis,
                                                                          color:
                                                                              Colors.black38,
                                                                        ))
                                                                    : const SizedBox(
                                                                        width:
                                                                            0,
                                                                        height:
                                                                            0,
                                                                      )
                                                              ],
                                                            )
                                                          : SizedBox(
                                                              height: 0.h,
                                                            ),
                                                    ],
                                                  ),
                                                ],
                                              ),
                                            ),
                                          )
                                        : Container(
                                            height: 0,
                                            child: Text("111111111111"));
                                  },
                                ),
                              ),
                            )
                          : Container(
                              child: Text("102030102030"),
                            ),
                    ]),
              ),
            ),
          ),
        ));
  }

  static Future<void> showAboutUs(BuildContext context, String logoApp) async {
    return showAboutDialog(
      context: context,
      applicationIcon: SizedBox(
        height: 100.sp,
        width: 100.sp,
        child: Image(
          image: AssetImage("packages/dialog_pp_flutter/$logoApp"),
          fit: BoxFit.contain,
          alignment: Alignment.bottomCenter,
        ),
      ),
      // s,
      // applicationLegalese: apiModel!.aboutApp!.registrationDetail,
      applicationName: AppDetailsPP.to.appName.value,
      applicationVersion: AppDetailsPP.to.buildNumber.value,
      children: <Widget>[
        Padding(
            padding: EdgeInsets.only(top: 5.h),
            child: Text(AppDetailsPP.to.packageName.value))
      ],
    );
  }
}
